# Flutter Enhancement Suite - Snippets :scissors: 

- [Dart Snippets](https://github.com/marius-h/flutter_enhancement_suite/blob/master/SNIPPETS.md#dart-code-snippets)
- [Flutter Snippets](https://github.com/marius-h/flutter_enhancement_suite/blob/master/SNIPPETS.md#flutter-widget-snippets)
- [Hooks Snippets](https://github.com/marius-h/flutter_enhancement_suite/blob/master/SNIPPETS.md#flutter-hooks-snippets)

## Dart Code Snippets

| Snippet       | Description                                        |
| --------------| -------------------------------------------------- |
| `var`         | Dart variable declaration using `var`              |
| `final`       | Dart variable declaration using `final`            |
| `const`       | Dart variable declaration using `const`            |
| `invar`       | Dart public Instance variable                      |
| `prinvar`     | Dart private instance variable                     |
| `mt`          | Dart public method                                 |
| `prmt`        | Dart private method                                |
| `arr`         | Dart public arrow function                         |
| `prarr`       | Dart private arrow function                        |
| `oconst`      | Dart optional named parameters constructor         |
| `nconst`      | Dart optional named constructor                    |
| `list`        | Dart `List` collection                             |
| `map`         | Dart `Map` collection                              |
| `set`         | Dart `Set` collection                              |
| `getarr`      | Dart arrow function getter                         |
| `impas`       | Dart `import as`                                   |
| `impshow`     | Dart `import show`                                 |
| `impdeff`     | Dart `import deffered as`                          |
| `imphide`     | Dart `import hide`                                 |
| `exphide`     | Dart `export hide`                                 |
| `expshow`     | Dart `export show`                                 |
| `switch case` | Dart switch statement                              |
| `if`          | Dart if statement                                  |
| `if else`     | Dart if/else statement                             |
| `main`        | Dart main method                                   |

## Flutter Widget Snippets

| Snippet         | Description                                                                                |
| -----------     | --------------------------------------------------------------------------------           |
| `fimpmat`       | Add import to material's package                                                           |
| `fimpcup`       | Add import to cupertino's package                                                          |
| `fanimbuilder`  | Flutter `AnimatedBuilder` widget                                                           |
| `faspratio`     | Flutter `AspectRatio` widget                                                               |
| `fcent`         | Flutter `Center` widget                                                                    |
| `fcol`          | Flutter `Column` widget                                                                    |
| `fcont`         | Flutter `Container` widget                                                                 |
| `fcustomclipper`| Flutter `CustomClipper` widget                                                             |
| `fcustompainter`| Flutter `CustomPainter` widget                                                             |
| `fcustomscroll` | Flutter `CustomScrollView` widget                                                          |
| `finall`        | Flutter `EdgeInsets` widget with named constructor `all`                                   |
| `finonly`       | Flutter `EdgeInsets` widget with named constructor `only`                                  |
| `finsym`        | Flutter `EdgeInsets` widget with named constructor `symmetric`                             |
| `finsymh`       | Flutter `EdgeInsets` widget with named constructor `symmetric` with `horizontal` parameter |
| `finsymv`       | Flutter `EdgeInsets` widget with named constructor `symmetric` with `vertical` parameter   |
| `fexp`          | Flutter `Expanded` widget                                                                  |
| `ffuturebuilder`| Flutter `FutureBuilder` widget                                                             |
| `ficon`         | Flutter `Icon` widget                                                                      |
| `flayoutbuilder`| Flutter `LayoutBuilder` widget                                                             |
| `flistvbuilder` | Flutter `ListView.builder()` widget                                                        |
| `fmedqh`        | Flutter `MediaQuery` widget with `height`                                                  |
| `fmedqw`        | Flutter `MediaQuery` widget with `width`                                                   |
| `forientbuilder`| Flutter `OrientationBuilder` widget                                                        |
| `frow`          | Flutter `Row` widget                                                                       |
| `fscaffold`     | Flutter `Scaffold` widget                                                                  |
| `fscaffoldab`   | Flutter `Scaffold` widget with `AppBar`                                                    |
| `fscaffoldabbn` | Flutter `Scaffold` widget with `AppBar` and `BottomNavigationBar`                          |
| `fscaffoldabfab`| Flutter `Scaffold` widget with `AppBar` and `FloatingActionButton`                         |
| `fscaffoldall`  | Flutter `Scaffold` widget with `AppBar`, `BottomNavigationBar` and `FloatingActionButton`  |
| `fdialog`       | Flutter `showDialog` method                                                                |
| `fsinglechildsc`| Flutter `SingleChildScrollView` widget                                                     |
| `fsb`           | Flutter `SizedBox` widget                                                                  |
| `fsbh`          | Flutter `SizedBox` widget with `height`                                                    |
| `fsbw`          | Flutter `SizedBox` widget with `width`                                                     |
| `fstfulbuilder` | Flutter `StatefulBuilder` widget                                                           |
| `fstreambuilder`| Flutter `StreamBuilder` widget                                                             |
| `ftext`         | Flutter `Text` widget                                                                      |


## Flutter Hooks Snippets

| Snippet            | Description                           |
| -------------------| --------------------------------------|
| `hook`             | New `Hook` widget                     |
| `uAnim`            | New `useAnimation` function           |
| `uAnimCont`        | New `useAnimationController` function |
| `uContext`         | New `useContext` function             |
| `uEffect`          | New `useEffect` function              |
| `uFuture`          | New `useFuture` function              |
| `uListenable`      | New `useListenable` function          |
| `uMem`             | New `useMemoized` function            |
| `uState`           | New `useState` function               |
| `uStream`          | New `useStream` function              |
| `uValChanged`      | New `useValueChanged` function        |
| `uValListenable`   | New `useValueListenable` function     |
| `uValNotifier`     | New `useValueNotifier` function       |